diff -r e16bdc0054ce src/industry_gui.cpp
--- a/src/industry_gui.cpp
+++ b/src/industry_gui.cpp
@@ -30,6 +30,7 @@
 #include "tilehighlight_func.h"
 #include "string_func.h"
 #include "sortlist_type.h"
+#include "widgets/dropdown_type.h"
 #include "widgets/dropdown_func.h"
 #include "company_base.h"
 #include "core/geometry_func.hpp"
@@ -41,6 +42,7 @@
 #include "widgets/industry_widget.h"
 
 #include "table/strings.h"
+#include "hotkeys.h"
 
 #include <bitset>
 
@@ -180,6 +182,21 @@
 	EndContainer(),
 	NWidget(WWT_PANEL, COLOUR_DARK_GREEN, WID_DPI_INFOPANEL), SetResize(1, 0),
 	EndContainer(),
+	NWidget(WWT_PANEL, COLOUR_DARK_GREEN), SetResize(1, 0),
+		NWidget(NWID_HORIZONTAL), SetPIP(2, 0, 2),
+			NWidget(WWT_LABEL, COLOUR_DARK_GREEN), SetMinimalSize(140, 14), SetDataTip(STR_FUND_INDUSTRY_FORBIDDEN_TILES_TITLE, STR_NULL),
+			NWidget(NWID_SPACER), SetFill(1, 0),
+		EndContainer(),
+		NWidget(NWID_HORIZONTAL), SetPIP(2, 0, 2),
+			NWidget(NWID_SPACER), SetFill(1, 0),
+			NWidget(WWT_TEXTBTN, COLOUR_GREY, WID_DPI_FT_OFF), SetMinimalSize(60, 12),
+											SetDataTip(STR_FUND_INDUSTRY_FORBIDDEN_TILES_OFF, STR_FUND_INDUSTRY_FORBIDDEN_TILES_OFF_TOOLTIP),
+			NWidget(WWT_TEXTBTN, COLOUR_GREY, WID_DPI_FT_ON), SetMinimalSize(60, 12),
+											SetDataTip(STR_FUND_INDUSTRY_FORBIDDEN_TILES_ON, STR_FUND_INDUSTRY_FORBIDDEN_TILES_ON_TOOLTIP),
+			NWidget(NWID_SPACER), SetFill(1, 0),
+		EndContainer(),
+		NWidget(NWID_SPACER), SetMinimalSize(0, 2),
+	EndContainer(),
 	NWidget(NWID_HORIZONTAL),
 		NWidget(WWT_TEXTBTN, COLOUR_DARK_GREEN, WID_DPI_DISPLAY_WIDGET), SetFill(1, 0), SetResize(1, 0),
 				SetDataTip(STR_INDUSTRY_DISPLAY_CHAIN, STR_INDUSTRY_DISPLAY_CHAIN_TOOLTIP),
@@ -188,14 +205,6 @@
 	EndContainer(),
 };
 
-/** Window definition of the dynamic place industries gui */
-static WindowDesc _build_industry_desc(
-	WDP_AUTO, "build_industry", 170, 212,
-	WC_BUILD_INDUSTRY, WC_NONE,
-	WDF_CONSTRUCTION,
-	_nested_build_industry_widgets, lengthof(_nested_build_industry_widgets)
-);
-
 /** Build (fund or prospect) a new industry, */
 class BuildIndustryWindow : public Window {
 	int selected_index;                         ///< index of the element in the matrix
@@ -206,6 +215,7 @@
 	IndustryType index[NUM_INDUSTRYTYPES + 1];  ///< Type of industry, in the order it was loaded
 	bool enabled[NUM_INDUSTRYTYPES + 1];        ///< availability state, coming from CBID_INDUSTRY_PROBABILITY (if ever)
 	Scrollbar *vscroll;
+	bool funding_enabled;
 
 	/** The offset for the text in the matrix. */
 	static const int MATRIX_TEXT_OFFSET = 17;
@@ -254,20 +264,24 @@
 		if (this->selected_index == -1) {
 			this->selected_index = 0;
 			this->selected_type = this->index[0];
+			SetIndustryForbiddenTilesHighlight(this->selected_type);
 		}
 
 		this->vscroll->SetCount(this->count);
+
+		this->funding_enabled = (_game_mode == GM_EDITOR || Company::IsValidID(_local_company));
 	}
 
 	/** Update status of the fund and display-chain widgets. */
 	void SetButtons()
 	{
-		this->SetWidgetDisabledState(WID_DPI_FUND_WIDGET, this->selected_type != INVALID_INDUSTRYTYPE && !this->enabled[this->selected_index]);
+		this->SetWidgetDisabledState(WID_DPI_FUND_WIDGET,  !this->funding_enabled || (this->selected_type != INVALID_INDUSTRYTYPE && !this->enabled[this->selected_index]));
 		this->SetWidgetDisabledState(WID_DPI_DISPLAY_WIDGET, this->selected_type == INVALID_INDUSTRYTYPE && this->enabled[this->selected_index]);
+		this->LowerWidget(_settings_client.gui.show_industry_forbidden_tiles + WID_DPI_FT_OFF);
 	}
 
 public:
-	BuildIndustryWindow() : Window(&_build_industry_desc)
+	BuildIndustryWindow(WindowDesc *desc) : Window(desc)
 	{
 		this->timer_enabled = _loaded_newgrf_features.has_newindustries;
 
@@ -275,6 +289,7 @@
 		this->selected_type = INVALID_INDUSTRYTYPE;
 
 		this->callback_timer = DAY_TICKS;
+		this->funding_enabled = false;
 
 		this->CreateNestedTree();
 		this->vscroll = this->GetScrollbar(WID_DPI_SCROLLBAR);
@@ -283,6 +298,11 @@
 		this->SetButtons();
 	}
 
+	~BuildIndustryWindow()
+	{
+		SetIndustryForbiddenTilesHighlight(INVALID_INDUSTRYTYPE);
+	}
+
 	virtual void OnInit()
 	{
 		this->SetupArrays();
@@ -492,6 +512,7 @@
 				if (y < this->count) { // Is it within the boundaries of available data?
 					this->selected_index = y;
 					this->selected_type = this->index[y];
+					SetIndustryForbiddenTilesHighlight(this->selected_type);
 					const IndustrySpec *indsp = (this->selected_type == INVALID_INDUSTRYTYPE) ? NULL : GetIndustrySpec(this->selected_type);
 
 					this->SetDirty();
@@ -535,6 +556,16 @@
 				}
 				break;
 			}
+
+			case WID_DPI_FT_OFF:
+			case WID_DPI_FT_ON:
+				this->RaiseWidget(_settings_client.gui.show_industry_forbidden_tiles + WID_DPI_FT_OFF);
+				_settings_client.gui.show_industry_forbidden_tiles = (widget != WID_DPI_FT_OFF);
+				this->LowerWidget(_settings_client.gui.show_industry_forbidden_tiles + WID_DPI_FT_OFF);
+				if (_settings_client.sound.click_beep) SndPlayFx(SND_15_BEEP);
+				this->SetDirty();
+				MarkWholeScreenDirty();
+				break;
 		}
 	}
 
@@ -603,12 +634,12 @@
 
 	virtual void OnTimeout()
 	{
-		this->RaiseButtons();
+		this->RaiseWidget(WID_DPI_FUND_WIDGET);
 	}
 
 	virtual void OnPlaceObjectAbort()
 	{
-		this->RaiseButtons();
+		this->RaiseWidget(WID_DPI_FUND_WIDGET);
 	}
 
 	/**
@@ -625,13 +656,37 @@
 		if (indsp == NULL) this->enabled[this->selected_index] = _settings_game.difficulty.industry_density != ID_FUND_ONLY;
 		this->SetButtons();
 	}
+
+	virtual EventState OnHotkey(int hotkey)
+	{
+		return Window::OnHotkey(hotkey);
+	}
+
+	static HotkeyList hotkeys;
 };
 
+static Hotkey build_industry_hotkeys[] = {
+	Hotkey((uint16)0, "display_chain", WID_DPI_DISPLAY_WIDGET),
+	Hotkey((uint16)0, "build_button", WID_DPI_FUND_WIDGET),
+	HOTKEY_LIST_END
+};
+
+HotkeyList BuildIndustryWindow::hotkeys("industry_fund_gui", build_industry_hotkeys);
+
+/** Window definition of the dynamic place industries gui */
+static WindowDesc _build_industry_desc(
+	WDP_AUTO, "build_industry", 170, 212,
+	WC_BUILD_INDUSTRY, WC_NONE,
+	WDF_CONSTRUCTION,
+	_nested_build_industry_widgets, lengthof(_nested_build_industry_widgets),
+	&BuildIndustryWindow::hotkeys
+);
+
+
 void ShowBuildIndustryWindow()
 {
-	if (_game_mode != GM_EDITOR && !Company::IsValidID(_local_company)) return;
 	if (BringWindowToFrontById(WC_BUILD_INDUSTRY, 0)) return;
-	new BuildIndustryWindow();
+	new BuildIndustryWindow(&_build_industry_desc);
 }
 
 static void UpdateIndustryProduction(Industry *i);
@@ -1059,6 +1114,7 @@
 			NWidget(NWID_HORIZONTAL),
 				NWidget(WWT_TEXTBTN, COLOUR_BROWN, WID_ID_DROPDOWN_ORDER), SetDataTip(STR_BUTTON_SORT_BY, STR_TOOLTIP_SORT_ORDER),
 				NWidget(WWT_DROPDOWN, COLOUR_BROWN, WID_ID_DROPDOWN_CRITERIA), SetDataTip(STR_JUST_STRING, STR_TOOLTIP_SORT_CRITERIA),
+				NWidget(WWT_DROPDOWN, COLOUR_BROWN, WID_ID_DROPDOWN_FILTER), SetDataTip(STR_BUTTON_FILTER, STR_TOOLTIP_FILTER_CRITERIA),
 				NWidget(WWT_PANEL, COLOUR_BROWN), SetResize(1, 0), EndContainer(),
 			EndContainer(),
 			NWidget(WWT_PANEL, COLOUR_BROWN, WID_ID_INDUSTRY_LIST), SetDataTip(0x0, STR_INDUSTRY_DIRECTORY_LIST_CAPTION), SetResize(1, 1), SetScrollbar(WID_ID_SCROLLBAR), EndContainer(),
@@ -1086,6 +1142,10 @@
 	static const StringID sorter_names[];
 	static GUIIndustryList::SortFunction * const sorter_funcs[];
 
+	/* type_filter[industry_type] is set to true if player wishes that type to by displayed */
+	static bool type_filter[NUM_INDUSTRYTYPES];
+	static bool initialized;
+
 	GUIIndustryList industries;
 	Scrollbar *vscroll;
 
@@ -1097,7 +1157,9 @@
 
 			const Industry *i;
 			FOR_ALL_INDUSTRIES(i) {
-				*this->industries.Append() = i;
+				if (this->type_filter[i->type]){
+					*this->industries.Append() = i;
+				}
 			}
 
 			this->industries.Compact();
@@ -1229,9 +1291,17 @@
 		}
 	}
 
+	void initIndustryTypeFilter()
+	{
+		for (IndustryType indt = 0; indt < NUM_INDUSTRYTYPES; ++indt)
+			this->type_filter[indt] = true;
+			IndustryDirectoryWindow::initialized = true;
+	}
+
 public:
 	IndustryDirectoryWindow(WindowDesc *desc, WindowNumber number) : Window(desc)
 	{
+		if (IndustryDirectoryWindow::initialized == false) this->initIndustryTypeFilter();
 		this->CreateNestedTree();
 		this->vscroll = this->GetScrollbar(WID_ID_SCROLLBAR);
 
@@ -1300,6 +1370,11 @@
 				break;
 			}
 
+			case WID_ID_DROPDOWN_FILTER: {
+				size->width = 65;
+				break;
+			}
+
 			case WID_ID_INDUSTRY_LIST: {
 				Dimension d = GetStringBoundingBox(STR_INDUSTRY_DIRECTORY_NONE);
 				for (uint i = 0; i < this->industries.Length(); i++) {
@@ -1328,6 +1403,22 @@
 				ShowDropDownMenu(this, IndustryDirectoryWindow::sorter_names, this->industries.SortType(), WID_ID_DROPDOWN_CRITERIA, 0, 0);
 				break;
 
+			case WID_ID_DROPDOWN_FILTER: {
+				DropDownList *list = new DropDownList();
+				*list->Append() = new DropDownListStringItem(STR_BUTTON_FILTER_SELECT_ALL,     -2, false);
+				*list->Append() = new DropDownListStringItem(STR_BUTTON_FILTER_SELECT_NONE,    -1, false);
+				*list->Append() = new DropDownListItem(-3, false);
+
+				for (IndustryType indt = 0; indt < NUM_INDUSTRYTYPES; ++indt) {
+					const IndustrySpec *inds = GetIndustrySpec(indt);
+					if (inds->enabled)
+						*list->Append() = new DropDownListCheckedItem(inds->name, indt, false, IndustryDirectoryWindow::type_filter[indt]);
+				}
+
+				ShowDropDownList(this, list, -2, WID_ID_DROPDOWN_FILTER, 0, true, false);
+				break;
+			}
+
 			case WID_ID_INDUSTRY_LIST: {
 				uint p = this->vscroll->GetScrolledRowFromWidget(pt.y, this, WID_ID_INDUSTRY_LIST, WD_FRAMERECT_TOP);
 				if (p < this->industries.Length()) {
@@ -1344,10 +1435,27 @@
 
 	virtual void OnDropdownSelect(int widget, int index)
 	{
-		if (this->industries.SortType() != index) {
-			this->industries.SetSortType(index);
-			this->BuildSortIndustriesList();
+		if (widget == WID_ID_DROPDOWN_CRITERIA) {
+			if (this->industries.SortType() != index) {
+				this->industries.SetSortType(index);
+			}
 		}
+		else if (widget == WID_ID_DROPDOWN_FILTER) {
+			if ( index == -1 ) { // aka SELECT NONE
+				for (IndustryType indt = 0; indt < NUM_INDUSTRYTYPES; ++indt)
+					IndustryDirectoryWindow::type_filter[indt] = false;
+				// must SetDurty to force redraw of the listing widget
+				this->SetDirty();
+			}
+			else if ( index == -2 ) { // aka SELECT ALL
+				for (IndustryType indt = 0; indt < NUM_INDUSTRYTYPES; ++indt)
+					IndustryDirectoryWindow::type_filter[indt] = true;
+			}
+			else
+				IndustryDirectoryWindow::type_filter[index] = IndustryDirectoryWindow::type_filter[index] ? false: true;
+			this->industries.ForceRebuild();
+		}
+		this->BuildSortIndustriesList();
 	}
 
 	virtual void OnResize()
@@ -1385,6 +1493,8 @@
 
 Listing IndustryDirectoryWindow::last_sorting = {false, 0};
 const Industry *IndustryDirectoryWindow::last_industry = NULL;
+bool IndustryDirectoryWindow::initialized = false;
+bool IndustryDirectoryWindow::type_filter[NUM_INDUSTRYTYPES];
 
 /* Available station sorting functions. */
 GUIIndustryList::SortFunction * const IndustryDirectoryWindow::sorter_funcs[] = {
diff -r e16bdc0054ce src/industry_type.h
--- a/src/industry_type.h
+++ b/src/industry_type.h
@@ -12,6 +12,8 @@
 #ifndef INDUSTRY_TYPE_H
 #define INDUSTRY_TYPE_H
 
+#include "tile_type.h"
+
 typedef uint16 IndustryID;
 typedef uint16 IndustryGfx;
 typedef uint8 IndustryType;
@@ -38,5 +40,6 @@
 static const int INDUSTRY_COMPLETED = 3; ///< final stage of industry construction.
 
 void CheckIndustries();
+bool CanBuildIndustryOnTile(IndustryType type, TileIndex tile);
 
 #endif /* INDUSTRY_TYPE_H */
diff -r e16bdc0054ce src/main_gui.cpp
--- a/src/main_gui.cpp
+++ b/src/main_gui.cpp
@@ -107,7 +107,7 @@
 	if (_settings_client.sound.click_beep) SndPlayFx(SND_15_BEEP);
 	w->SetDirty();
 
-	if (w->IsWidgetLowered(widget)) {
+	if (w->IsWidgetLowered(widget) && mode == _thd.place_mode) {
 		ResetObjectToPlace();
 		return false;
 	}
@@ -227,6 +227,7 @@
 	GHK_TOGGLE_INVISIBILITY = GHK_TOGGLE_TRANSPARENCY + 9,
 	GHK_TRANSPARENCY_TOOLBAR = GHK_TOGGLE_INVISIBILITY + 8,
 	GHK_TRANSPARANCY,
+	GHK_BORROW_ALL,
 	GHK_CHAT,
 	GHK_CHAT_ALL,
 	GHK_CHAT_COMPANY,
@@ -393,6 +394,10 @@
 				ResetRestoreAllTransparency();
 				break;
 
+			case GHK_BORROW_ALL:
+				DoCommandP(0, 0, 1, CMD_INCREASE_LOAN | CMD_MSG(STR_ERROR_CAN_T_BORROW_ANY_MORE_MONEY));
+				break;
+
 #ifdef ENABLE_NETWORK
 			case GHK_CHAT: // smart chat; send to team if any, otherwise to all
 				if (_networking) {
@@ -465,6 +470,11 @@
 		InvalidateWindowData(WC_MAIN_TOOLBAR, 0, data, true);
 	}
 
+	virtual void OnMouseOver(Point pt, int widget)
+	{
+		if (_game_mode != GM_MENU && _settings_client.gui.enable_extra_tooltips && pt.x != -1) GuiPrepareTooltipsExtra(this);
+	}
+
 	static HotkeyList hotkeys;
 };
 
@@ -511,6 +521,7 @@
 	Hotkey('8' | WKC_CTRL | WKC_SHIFT, "invisibility_catenary", GHK_TOGGLE_INVISIBILITY + 7),
 	Hotkey('X' | WKC_CTRL, "transparency_toolbar", GHK_TRANSPARENCY_TOOLBAR),
 	Hotkey('X', "toggle_transparency", GHK_TRANSPARANCY),
+	Hotkey(WKC_NONE, "borrow_all", GHK_BORROW_ALL),
 #ifdef ENABLE_NETWORK
 	Hotkey(_ghk_chat_keys, "chat", GHK_CHAT),
 	Hotkey(_ghk_chat_all_keys, "chat_all", GHK_CHAT_ALL),
